use strict;
#-------------------------------------------------------------------------------
# TAG escape module
#						(C)2005-2006 nabe / nabe@abk.nu
#-------------------------------------------------------------------------------
package Satsuki::TextParser::TagEscape;
our $VERSION = '1.00';
#-------------------------------------------------------------------------------
# ץȥ ǧ°
#-------------------------------------------------------------------------------
my %PROTOCOL_CHECK = (
	href => 1, src => 1, site => 1, cite => 1, background => 1, action => 1
);
#-------------------------------------------------------------------------------
###############################################################################
# ܽ
###############################################################################
#------------------------------------------------------------------------------
# ڥ󥹥ȥ饯
#------------------------------------------------------------------------------
sub new {
	my $class = shift;
	my $self  = {};
	bless($self, $class);	# $self 򤳤Υ饹ȴϢդ
	$self->{ROBJ} = shift;

	$self->init(@_);	# 

	return $self;
}

#------------------------------------------------------------------------------
# ڥǥȥ饯
#------------------------------------------------------------------------------
sub DESTROY {
}

###############################################################################
# 
###############################################################################
#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub init {
	my $self   = shift;
	my ($file) = @_;
	my $ROBJ   = $self->{ROBJ};

	my $lines = $ROBJ->fread_lines_cached($file);
	my %tag_allow;
	my @allow_tags;
	while(@$lines) {
		my $x = shift(@$lines);
		chomp($x);
		if ($x eq '' || ord($x) == 0x23) { next; }	# '#'ǻϤޤԤϥ
		my ($tag, $attri) = split(/\s+/, $x, 2);
		if ($attri eq '') {
			$tag_allow{$tag} = [];
		} else {
			my @ary = split(/\s*,\s*/, $attri);
			$tag_allow{$tag} = \@ary;
		}
		if ($tag_allow{_module_start}) { last; }
	}
	# ⥸塼ǡΥ
	my %modules;
	my ($name, $html);
	push(@$lines, "\n");
	foreach(@$lines) {
		chomp($_);
		if (ord($_) == 0x23) { next; }	# '#'ǻϤޤԤϥ
		if (defined $name) {
			if ($_ ne '') { $html .= "$_\n"; next; }
			# ⥸塼
			chomp($html);
			$modules{$name} = $html;
			$name = $html = undef;
		}
		if (ord($_) != 0x2a) { next; }		# * ǻϤޤʤԤ̵
		# *name Ȥ
		$name = substr($_,1);
	}
	# ¸
	if ($tag_allow{_base})     { $self->{allow_base}     = join(', ', @{ $tag_allow{_base} });     }
	if ($tag_allow{_protocol}) { $self->{allow_protocol} = join(', ', @{ $tag_allow{_protocol} }); }
	$self->{allow_anytag}        = (exists $tag_allow{_allow_anytag});
	$self->{force_absolute_path} = (exists $tag_allow{_force_absolute_path});
	$self->{force_absolute_uri}  = (exists $tag_allow{_force_absolute_uri});
	$self->{tag_allow} = \%tag_allow;
	$self->{modules}   = \%modules;
}

#------------------------------------------------------------------------------
# 
#------------------------------------------------------------------------------
sub escape {
	my $self  = shift;
	my $ROBJ  = $self->{ROBJ};
	my ($inp) = @_;

	# 
	my @out;
	my $tag;
	my $tag_list     = $self->{tag_allow};
	my $mod_list     = $self->{modules};
	my $tag_check    = (! $self->{allow_anytag});
	my $attris_all   = $tag_list->{_base};
	my $protocols    = $tag_list->{_protocol};
	my $comment      = $tag_list->{_comment};
	my $style_secure = $tag_check && $tag_list->{_style_secure};
	# ХѥURI񤭴
	my $abs_uri    = (exists $tag_list->{_force_absolute_uri});
	my $abs_path   = (exists $tag_list->{_force_absolute_path}) || $abs_uri;
	my $basepath   = $ROBJ->{Basepath};
	my $server_url;
	if ($abs_uri) { $server_url = $ROBJ->{Server_url}; }

	### Ƚ or 
	my @comments;
	$inp =~ s/[\x01\x02\x03]//g;	# escape
	if (exists $tag_list->{_comment}) {		# 
		$inp =~ s/(<!--.*?-->)/push(@comments,$1),"\x01$#comments\x01"/seg;
	} else {		# 
		$inp =~ s/<!--.*?-->//sg;
	}

	### print "Content-Type: text/plain;\n\n";
	my @modules;
	$inp =~ s[<>][<module_end>]eg;
	while($inp =~ /^(.*?)<((?:\/module|[\@\w](?:[^>"']|[=\s\n]".*?"|[=\s\n]'.*?')*?))>(.*)/s) {
		my $x   = $1;		# ʬ
		$inp    = $3;		# Ĥ
		my $tag = $2;		# ʬ
		$x   =~ s[</(.+?)>][(!$tag_check || exists $tag_list->{$1}) && "\x02/$1\x03"]seg;
		$x   =~ s/</&lt;/g;
		$x   =~ s/>/&gt;/g;
		push(@out, $x);
		$tag =~ s/</&lt;/g;
		$tag =~ s/>/&gt;/g;

		# ʸ֤
		my @str;
		$tag =~ s/(=?\s?)[\s\n]*"(.*?)"|(=?\s?)[\s\n]*'(.*?)'/push(@str, "$2$4"), "$1$3<$#str>"/seg;
		$tag =~ s/[\n\s]*=[\n\s]*/=/sg;

		my ($tag_name, @x) = split(/ +/, $tag);
		$tag_name =~ tr/A-Z/a-z/;	# ʸѴ
		# ⥸塼륿
		if ($tag_name eq 'module' || $tag_name eq '/module') {
			my $data      = {};
			my $data_uri  = {};
			my $data_safe = {};
			my $name;
			if ($tag_name eq 'module') {
				foreach my $at (@x) {
					my ($n,$v) = split('=', $at, 2);
					$v =~ s/^<(\d+?)>$/$str[$1]/;
					$v =~ s/</&lt;/g;
					$v =~ s/>/&gt;/g;
					$v =~ s/"/&quot;/g;
					$v =~ s/'/&#39;/g;
					$data->{$n} = $v;
					# uri 󥳡
					my $v2=$v;
					$v =~ s/([^\.\/\~\*\-\w=\?\&:; ])/'%' . unpack('H2',$1)/eg;
					$v =~ s/script:/script%3a/i;
					$data_uri->{$n} = $v;
					# ʸǡ
					$v2 =~ s/\W//g;
					$data_safe->{$n} = $v2;
				}
				$name = $data->{name};
				$data_uri->{serverurl} = $ROBJ->{Server_url};
				$data_uri->{basepath}  = $basepath;
				$data_uri->{baseurl}   = $ROBJ->{Server_url} . $basepath;
				if (exists $mod_list->{"${name}::end"}) {	# block ⥸塼롩
					push(@modules, $data, $data_uri, $data_safe);
				}
			} else {
				$data_safe = pop(@modules) || {};
				$data_uri  = pop(@modules) || {};
				$data      = pop(@modules) || {};
				$name      = $data->{name} . '::end';
			}
			# ִ
			my $html = $mod_list->{ $name };
			$html =~ s/\#\{(\w+)(?:\|([^\}]*))?\}/  (exists $data->{$1}    )  ? $data->{$1}      : $2/eg;
			$html =~ s/\$\{(\w+)(?:\|([^\}]*))?\}/  (exists $data_uri->{$1})  ? $data_uri->{$1}  : $2/eg;
			$html =~ s/\$\$\{(\w+)(?:\|([^\}]*))?\}/(exists $data_safe->{$1}) ? $data_safe->{$1} : $2/eg;
			push(@out, $html);
			next;
		}

		# Ĥ줿
		my $attris = $tag_list->{$tag_name};
		if ($tag_check && !defined $attris) { next; }
		my @y = ($tag_name);

		my ($at, $n, $v);
		my ($last_at, $last_val);
		foreach $at (@x) {
			my ($n,$v) = split('=', $at, 2);
			$n =~ tr/A-Z/a-z/;	# ʸѴ

			my $flag = 1;
			if (ord($attris->[0]) == 0x2a) { next; } # '*'ǻϤޤ = °ʤ
			foreach(@$attris_all) {
				if ($_ eq $n) { $flag=0; last; }
			}
			if ($flag) {
				foreach(@$attris) {
					if ($_ eq $n) { $flag=0; last; }
				}
			}
			if ($tag_check && $flag) { next; }	# °̵

			# ʸ
			$v =~ s/^<(\d+?)>$/$str[$1]/;

			# 󥯥ץȥǧ href, src ʤɡXSSк
			if ($PROTOCOL_CHECK{$n}) {
				$v =~ s/&#(?:0*58|x0*3a);/:/;
				my $b = index($v, ':');
				if ($b >= 0) {
					$b = substr($v, 0, $b);
					$flag = 1;
					foreach(@$protocols) {
						if ($_ eq $b) { $flag=0; last; }
					}
					if ($tag_check && $flag) { next; }	# ̵

				} elsif ($abs_path) {
					# Хѥ/URIХѥ/URI˽񤭴
					if (ord($v) != 0x2f) { $v = $basepath . $v; }	# / ǻϤޤäƤʤ
					$v =~ s|([^\.])\./|$1|g;
					$v = $server_url . $v;
				} elsif (ord($v) != 0x2f && substr($v, 0, 2) ne './') {
					$v = './' . $v;
				}
			}

			# 륷ȻXSSк
			if ($style_secure && $n eq 'style') {
				$v =~ s/[\\\@\x00-\x1f\x80-\xff]//g;		# ASCIIʸʳ
				# ʸν
				while($v =~ m[/\*|\*/&#|script|java|exp|eval|cookie|include]i) {
					$v =~ s[/\*|\*/&#|script|java|exp|eval|cookie|include][]ig;
				}
			}
			# ĥ
			$v =~ s/"/&quot;/g;
			push(@y, "$n=\"$v\"");
			$last_at  = $n;
			$last_val = $v;
		}
		if ($#y >= 0) {
			if (ord(substr($last_val, -1)) > 0x7f) {	# XSSк
				if ($last_at eq 'title' || $last_at eq 'alt') {
					$y[$#y] = "$last_at=\"$last_val \"";	# spaceղ
				} else {
					push(@y, 'xss=""');	# dummy°ղ
				}
			}
			push(@out, '<' . join(' ', @y) . '>');
		}
	}
	$inp =~ s[</(.+?)>][(!$tag_check || exists $tag_list->{$1}) && "\x02/$1\x03"]seg;
	$inp =~ s/</&lt;/g;
	$inp =~ s/>/&gt;/g;
	my $out = join('', @out) . $inp;

	# 
	$out =~ s/\x01(\d+?)\x01/$comments[$1]/g;
	# Ĥ
	$out =~ tr/\x02\x03/<>/;

	# CSSXSSк
	if (exists $tag_list->{_escape_cssxss}) {
		$out =~ s/{/&#123;/g;
	}
	# 
	return $out;
}

#------------------------------------------------------------------------------
# ĥꥹȤ
#------------------------------------------------------------------------------
sub load_allowtags {
	my ($self, $skelton) = @_;
	my $tags = $self->{tag_allow};
	my @keys = sort keys(%$tags);

	my @ary;
	foreach(@keys) {
		if (substr($_, 0, 1) eq '_') { next; }
		my %h;
		$h{tag}    = $_;
		$h{attris} = join(", ", @{ $tags->{$_} });
		push(@ary, \%h);
	}
	return \@ary;
}

1;	# ޤʤ
